﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Text;
using System.Threading.Tasks;
using WcfTest.Extends;
using WcfTest.Service;

namespace WcfTest.Client
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.ReadLine();
            var factory = new ChannelFactory<IPersonSvc>("*");
            factory.Endpoint.EndpointBehaviors.Add(new ChesEndpointBehavior());
            var channel = factory.CreateChannel();
            int value = 0;
            try {
             value = channel.GetValue();
            }
            catch (Exception ex) {
                Console.WriteLine(ex.Message);
            }
            Console.WriteLine(value);
            factory.Close();
            Console.ReadLine();
        }
    }
}
