﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel.Channels;
using System.ServiceModel.Dispatcher;
using System.Text;
using System.Threading.Tasks;

namespace WcfTest.Extends
{
   public  class ChesClientMessageInspector : IClientMessageInspector
    {
        public void AfterReceiveReply(ref System.ServiceModel.Channels.Message reply, object correlationState)
        {
            //接受服务端发送过来的消息
            foreach (var sub in reply.Headers)
            {
                var index = reply.Headers.FindHeader(sub.Name, sub.Namespace);
                var value = reply.Headers.GetHeader<string>(index);
                Console.WriteLine(value);
            }


            //throw new NotImplementedException();
        }
        // 在将请求消息发送到服务之前，启用消息的检查或修改。
        public object BeforeSendRequest(ref System.ServiceModel.Channels.Message request, System.ServiceModel.IClientChannel channel)
        {
            //向服务端发送消息
            var userNameHeader = MessageHeader.CreateHeader("OperationUserName", "http://tempuri.org", "fangxing", false, "");
            var pwdNameHeader = MessageHeader.CreateHeader("OperationPwd", "http://tempuri.org", "password", false, "");
            request.Headers.Add(userNameHeader);
            request.Headers.Add(pwdNameHeader);
            //Console.WriteLine(request);
            //return null;  
            return System.Guid.NewGuid();
        }
    }
}
