﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.ServiceModel.Dispatcher;
using System.Text;
using System.Threading.Tasks;

namespace WcfTest.Extends
{
   public  class ChesDispatchMessageInspector : IDispatchMessageInspector
    {
        public object AfterReceiveRequest(ref System.ServiceModel.Channels.Message request, System.ServiceModel.IClientChannel channel, System.ServiceModel.InstanceContext instanceContext)
        {
            //接受客户端发送过来的消息
            var user = GetHeaderValue("OperationUserName");
            var pwd = GetHeaderValue("OperationPwd");
            if (user != "fangxing" || pwd != "password")
                throw new FaultException("Invalid User!");
            return null;  
        }

        public void BeforeSendReply(ref System.ServiceModel.Channels.Message reply, object correlationState)
        {
            //throw new NotImplementedException();
            //向客户端发送消息
            reply.Headers.Add(MessageHeader.CreateHeader("UserToken",
                "http://tempuri.org",
                "lkjasdjfoasiidfga23165431as6dfasdfa846168451asdfadf418451800000000"));
        }

        private string GetHeaderValue(string name, string ns = "http://tempuri.org")
        {
            var headers = OperationContext.Current.IncomingMessageHeaders;
            var index = headers.FindHeader(name, ns);
            if (index > -1)
                return headers.GetHeader<string>(index);
            else
                return null;
        }  
    }
}
