﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.ServiceModel;
using System.Text;
using System.Threading.Tasks;
using WcfTest.Extends;

namespace WcfTest.Service.Host
{
    class Program
    {
        static void Main(string[] args)
        {
            ServiceHost host = new ServiceHost(typeof(PersonSvc));
            foreach (var sub in host.Description.Endpoints)
            {
                sub.EndpointBehaviors.Add(new ChesEndpointBehavior());
            }


            host.Open();

            Console.WriteLine("服务已启动");
            Console.Read();

        }
    }
}
